#include <windows.h>
#include <commctrl.h>
#include <stdio.h>
#include <tchar.h>

#include "resource.h"

#define	TIMER_ID	200
#define IOCTL_RDMSR_CODE 0x800

#define IA32_TEMPERATURE_TARGET	0x01a2
#define IA32_THERM_STATUS		0x019c

#pragma comment(lib,"comctl32.lib")

LRESULT CALLBACK DlgProc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam);	//	_CAO{bNXvV[W[
BOOL RDMSR(HANDLE h, DWORD32 adr,DWORD64* data);
int GetCPUMax(void);	//	_CPU擾

HINSTANCE hInst;


int WINAPI WinMain(HINSTANCE hCurInst, HINSTANCE hPrevInst, LPSTR lpsCmdLine, int nCmdShow){
	::hInst = hCurInst;
	DialogBox(hCurInst, TEXT("DLG1"), 0, (DLGPROC)DlgProc);
	return (int)0;
}

//	_CAO{bNXvV[W[

LRESULT CALLBACK DlgProc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam){
	static int CPUMAX;
	static UINT_PTR tid;
	static HANDLE hFile;
	TCHAR buf[1024];
	switch (msg) {
	case WM_INITDIALOG:{
		CPUMAX = GetCPUMax();

		hFile = CreateFile(_TEXT("\\\\.\\msrtest"),
			GENERIC_READ | GENERIC_WRITE, 0, NULL, OPEN_EXISTING, 0, NULL);
		if (hFile == INVALID_HANDLE_VALUE){
			MessageBox(hDlg, _TEXT("CreateFiles܂"), _TEXT("G["), MB_OK);
			EndDialog(hDlg, TRUE);
		}
		tid = SetTimer(hDlg, TIMER_ID, 1000, NULL);	
		return TRUE;
	}
	case WM_TIMER:{
		buf[0] = _T('\0');
		int n;
		int error=0;
		HANDLE h = GetCurrentThread();

		for (n = 0; n < CPUMAX; n++){
			TCHAR s[32];
			SetThreadAffinityMask(h, 1 << n);
			int t,tjmax;
			DWORD64 temp;
			if (RDMSR(hFile, IA32_THERM_STATUS, &temp)==TRUE){
				t = (temp >> 16) & 0x7f;
				if (RDMSR(hFile, IA32_TEMPERATURE_TARGET, &temp)==TRUE){
					tjmax = (temp >> 16) & 0xff;
					_stprintf_s(s, sizeof(s) / sizeof(TCHAR), _TEXT("CPU%.2d:tjmax %d x %d\r\n"), n, tjmax,tjmax-t);
					_tcscat_s(buf, sizeof(buf) / sizeof(TCHAR), s);
				}else{
					_stprintf_s(s, sizeof(s) / sizeof(TCHAR), _TEXT("CPU%.2d:ex܂Ŏc%d\r\n"), n, t);
					_tcscat_s(buf, sizeof(buf) / sizeof(TCHAR), s);
				}
			}else{
				error=-1;
				break;
			}
		}
		if(error){
			KillTimer(hDlg, tid);
			CloseHandle(hFile);
			MessageBox(hDlg,_TEXT("̃VXeCPUx擾ł܂B"),_TEXT("G["),MB_OK);
			EndDialog(hDlg, TRUE);
		}
		SetWindowText(GetDlgItem(hDlg, IDC_EDIT100), buf);
		break;
	}
	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDCANCEL:	//	_CAȌI
			KillTimer(hDlg, tid);
			CloseHandle(hFile);
			EndDialog(hDlg, TRUE);
			return TRUE;
		default:
			return FALSE;
		}
	default:
		return FALSE;
	}
	return FALSE;
}

BOOL RDMSR(HANDLE h, DWORD32 adr,DWORD64* data){
	DWORD dwReturn;
	*data = adr;
	DeviceIoControl(h, IOCTL_RDMSR_CODE, data, sizeof(*data),
		data, sizeof(*data), &dwReturn, NULL);
	if (dwReturn == sizeof(DWORD64))
		return TRUE;
	else
		return FALSE;
}


//	_CPU擾

int GetCPUMax(void){
	SYSTEM_INFO sys;
	GetSystemInfo(&sys);
	return sys.dwNumberOfProcessors;
}
